;;;; run.scm - tests for protobj


(import test protobj)


(define a (%))
(test "\"a\" parent is root" #t (eq? (^ a) (current-root-object)))
(! a x 1)
(test "\"a\" slot \"x\" is 1" 1 (? a x))
(define b (% a))
(test "\"b\" inherited slot \"x\" is 1" 1 (? b x))
(! a x 42)
(test "\"b\" slot \"x\" is now 42" 42 (? b x))
(! b x 69)
(test "\"b\" slot \"x\" is 69" 69 (? b x))
(test "\"a\" slot \"x\" is still 42" 42 (? a x))
(! a xplus (lambda (self n) (+ (? self x) n)))
(test "42 + 7 = 49" 49 (@ a xplus 7))
(test "69 + 7 = 76" 76 (@ b xplus 7))
(test "42 + 7 = 49" 49 (@ a (xplus 1000) (xplus 7)))
(define c (% a (y 101)))
(test "\"c\" slot \"x\" is 42" 42 (? c x))
(test "\"c\" slot \"y\" is 101" 101 (? c y))
(define d (% a (x 1) (y 2) (z 3)))
(test "\"d\" slot \"x\" is 1" 1 (? d x))
(test "\"d\" slot \"y\" is 2" 2 (? d y))
(test "\"d\" slot \"z\" is 3" 3 (? d z))

#;(test
  "Copying object-raw-clone functions"
  `(((c . 9) (b . 8) (e . 7))
    ((clone . ,object-raw-clone/no-slots-copy)
     (a . 5) (d . 6) (e . 7) (b . 8) (c . 9)))
  (let* ((o (% (% (% (current-root-object)
		     (a 1) (b 2) (c 3))
		  (b 4) (a 5) (d 6))
	       (e 7) (b 8) (c 9))))
    (list
     (protobj-internal:slots (object-raw-clone/copy-immed-slots o))
     (protobj-internal:slots (object-raw-clone/copy-all-slots o)))))

;; TODO: Add more tests.

(test-exit)
